package de.intevation.flys.artifacts.model.minfo;

import org.apache.log4j.Logger;

import de.intevation.artifactdatabase.state.Facet;
import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;
import de.intevation.flys.artifacts.FLYSArtifact;
import de.intevation.flys.artifacts.model.DataFacet;
import de.intevation.flys.artifacts.model.FacetTypes;
import de.intevation.flys.artifacts.states.DefaultState.ComputeType;


public class MorphologicWidthFacet
extends DataFacet
implements   FacetTypes
{
    private static Logger logger = Logger.getLogger(SedimentLoadFacet.class);


    public MorphologicWidthFacet() {
    }

    public MorphologicWidthFacet(String facetName, String description) {
        super(facetName, description);
    }

    public MorphologicWidthFacet(int idx, String name, String description,
        ComputeType type, String stateId, String hash) {
        super(idx, name, description, type, hash, stateId);
    }

    public Object getData(Artifact artifact, CallContext context) {

        FLYSArtifact flys = (FLYSArtifact) artifact;
        String width_id = flys.getDataAsString("width_id");

        MorphologicWidth width =
            MorphologicWidthFactory.getWidth(Integer.valueOf(width_id));

        return width;
    }

    /** Copy deeply. */
    @Override
    public Facet deepCopy() {
        MorphologicWidthFacet copy = new MorphologicWidthFacet();
        copy.set(this);
        copy.type = type;
        copy.hash = hash;
        copy.stateId = stateId;
        return copy;
    }
}
